/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2010 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls.processors.impl;

import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 * Generates ID such as iii.iii.iii.iii-tttttttttt-c
 * @author cmarchand
 */
public class TstampIPUniqueId implements IdGenerator {
    private static long lastTime = System.currentTimeMillis();
    private static int count = 0;
    private String ip;
    public TstampIPUniqueId() {
        super();
        if(ip==null) {
            try {
                InetAddress addr = InetAddress.getLocalHost();
                // Get IP Address
                byte[] ipAddr = addr.getAddress();
                // Get hostname
                StringBuffer sb = new StringBuffer();
                for(byte i:ipAddr) {
                    sb.append(Byte.toString(i)).append(".");
                }
                ip = sb.toString();
                ip = ip.substring(0, ip.length()-1);
            } catch (UnknownHostException e) {
                ip = "127.0.0.1";
            }
        }
    }

    public String generateId() {
        long now = System.currentTimeMillis();
        if(now==lastTime) {
            count++;
        } else {
            lastTime = now;
            count = 0;
        }
        StringBuilder sb = new StringBuilder();
        sb.append(ip).append("-").append(Long.toString(now)).append("-").append(Integer.toBinaryString(count));
        return sb.toString();
    }

}
